#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "ppImage.h"

psString ppImageVersion(void)
{
#ifndef PPIMAGE_VERSION
#error "PPIMAGE_VERSION is not set"
#endif
#ifndef PPIMAGE_BRANCH
#error "PPIMAGE_BRANCH is not set"
#endif
    return psStringCopy(PPIMAGE_BRANCH "@" PPIMAGE_VERSION);
}

psString ppImageSource(void)
{
#ifndef PPIMAGE_SOURCE
#error "PPIMAGE_SOURCE is not set"
#endif
    return psStringCopy(PPIMAGE_SOURCE);
}

psString ppImageVersionLong(void)
{
    psString version = ppImageVersion();  // Version, to return
    psString source = ppImageSource();    // Source

    psStringPrepend(&version, "ppImage ");
    psStringAppend(&version, " from %s, built %s, %s", source, __DATE__, __TIME__);
    psFree(source);

#ifdef __OPTIMIZE__
    psStringAppend(&version, " optimised");
#else
    psStringAppend(&version, " unoptimised");
#endif

    return version;
};

void ppImageVersionMetadata(psMetadata *metadata)
{
    PS_ASSERT_METADATA_NON_NULL(metadata,);

    psString pslib = psLibVersionLong();// psLib version
    psString psmodules = psModulesVersionLong(); // psModules version
    psString psphot = psphotVersionLong(); // psphot version
    psString psastro = psastroVersionLong(); // psastro version
    psString ppStats = ppStatsVersionLong(); // ppStats version
    psString ppImage = ppImageVersionLong(); // ppImage version

    psTime *time = psTimeGetNow(PS_TIME_TAI); // The time now
    psString timeString = psTimeToISO(time); // The time in an ISO string
    psFree(time);
    psString head = NULL;               // Head string
    psStringAppend(&head, "ppImage processing at %s. Component information:", timeString);
    psFree(timeString);

    psMetadataAddStr(metadata, PS_LIST_TAIL, "HISTORY", PS_META_DUPLICATE_OK, head, "");
    psMetadataAddStr(metadata, PS_LIST_TAIL, "HISTORY", PS_META_DUPLICATE_OK, pslib, "");
    psMetadataAddStr(metadata, PS_LIST_TAIL, "HISTORY", PS_META_DUPLICATE_OK, psmodules, "");
    psMetadataAddStr(metadata, PS_LIST_TAIL, "HISTORY", PS_META_DUPLICATE_OK, psphot, "");
    psMetadataAddStr(metadata, PS_LIST_TAIL, "HISTORY", PS_META_DUPLICATE_OK, psastro, "");
    psMetadataAddStr(metadata, PS_LIST_TAIL, "HISTORY", PS_META_DUPLICATE_OK, ppStats, "");
    psMetadataAddStr(metadata, PS_LIST_TAIL, "HISTORY", PS_META_DUPLICATE_OK, ppImage, "");

    psFree(head);
    psFree(pslib);
    psFree(psmodules);
    psFree(psphot);
    psFree(psastro);
    psFree(ppStats);
    psFree(ppImage);

    return;
}
